#!/bin/sh
#   Copyright (c) 2010 digitalSTROM.org, Zurich, Switzerland
#
#   Author: Sergey 'Jin' Bostandzhyan <jin@mediatomb.cc>
#   Author: Michael Tross <michael.tross@aizo.com>
#
#   This file is part of digitalSTROM Server.
#
#   jsonlib.sh is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   funclib.sh is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this file. If not, see <http://www.gnu.org/licenses/>.

data_encode() {                                                                                      
    data="$1";
    data=`                                                                                       
       echo $data | hexdump -v -e '1/1 "%02x\t"' -e '1/1 "%_c\n"' |
       LANG=C awk '
           $1 ~ /0[AaDd]/ { printf("%%%s", $1); next }
           $1 == "20" { printf("%s", "%20"); next }
           $2 ~ /^[a-zA-Z0-9.*()\/-]$/ { printf("%s", $2); next }
           { printf("%%%s", $1) }
       '`                                                                                    
    echo -n $data
}  

json_ok() {
    echo "{ \"success\": true, \"code\": $ERR_OK, \"message\": \"OK\" }"
}

json_ok_info() {
    INFO=`data_encode "$1"`
    echo "{ \"success\": true, \"code\": $ERR_OK, \"message\": \"OK\", \"info\": \"$INFO\"  }"
}
	
json_status() {
    echo "{ \"success\": true, \"code\": $1, \"message\": \"$2\" }"
}

json_error() {
    echo "{ \"success\": false, \"code\": $1, \"message\": \"$2\" }"
}

json_error_update() {
    echo "{ \"success\": false, \"code\": $1, \"opkgcode\": $2, \"message\": \"$3\" }"
}

json_error_info() {
	INFO=`data_encode "$3"`
    echo "{ \"success\": false, \"code\": $1, \"message\": \"$2\", \"info\": \"$INFO\" }"
}

json_redirect() {
    MSG="OK"
    if [[ -n "$4" ]]; then
        MSG="$4"
    fi
    echo -n "{ \"success\": true, \"code\": $1, "
    echo    "\"message\": \"$MSG\", \"ip\": \"$2\", \"netmask\": \"$3\" }"
}
